include math.e
clear_screen()
--complex functions first coded in Euphoria July 10, 2004.

--Some functions that operate on complex numbers such as z=A+Bj, where j=sqrt(-1).
--complex numbers are sequences of two atoms and a tag.
--The first atom is the real part, the second is the imaginary part and
--a third atom is the character "c" to designate the sequence is a complex number.
--The functions that operate on complex numbers will take a simple two atom
--sequence as well as a sequence tagged as a complex number.

--type complex(sequence x)
--c_add(sequence x, sequence y)
--c_subtract(sequence x, sequence y)
--c_mult(sequence x, sequence y)
--c_reciprocal(sequence x)
--c_quotient(sequence x, sequence y)
--c_sqrt(sequence x)
--c_power(sequence x, atom p)
--c_sinh(sequence x)
--c_cosh(sequence x)
--c_tanh(sequence x)
--c_coth(sequence x)
--c_scalarmult(atom x, sequence y)
--c_Imscalarmult(atom x, sequence y)


--type trig_range(object x)
--  values passed to arccos and arcsin must be [-1,+1]
    --if atom(x) then
	--return x >= -1 and x <= 1
    --else
	--for i = 1 to length(x) do
	    --if not trig_range(x[i]) then
		--return 0
	    --end if
	--end for
	--return 1
    --end if
--end type

--Define a complex variable type.  Not necessary, but if general functions 
--that operate on regular number or complex types is programmed a 
--complex type will be necessary.
global type complex(sequence x)
if (length(x)=3 and (x[3]="c" or x[3]="C")) then
    return 1
else
    return 0
end if
end type

global function c_add(sequence x, sequence y)
sequence z 
--z=repeat(0,2)
    z={0,0,"c"}
    z[1]=x[1]+y[1]
    z[2]=x[2]+y[2]
    return z
end function

global function c_subtract(sequence x, sequence y)
sequence z 
    --z=repeat(0,2)
    z={0,0,"c"}
    z[1]=x[1]-y[1]
    z[2]=x[2]-y[2]
    return z
end function


global function c_mult(sequence x, sequence y)
sequence z
    z={0,0,"c"}
--z=repeat(0,2)
    z[1]=x[1]*y[1]-x[2]*y[2]
    z[2]=x[1]*y[2]+x[2]*y[1]
return z
end function

global function c_reciprocal(sequence x)
atom ysqr
sequence z
    z={0,0,"c"}
--z=repeat(0,2)
--1/z=1/(A+Bj)*(A-Bj)/(A-Bj)=(A-Bj)/(A^2+B^2)
    ysqr=power(x[1],2)+power(x[2],2)
    z[1]=x[1]/ysqr
    z[2]=-x[2]/ysqr
return z
end function

global function c_quotient(sequence x, sequence y)
atom ysqr
sequence z 
    z={0,0,"c"}
--repeat(0,2)
--x/y=z
    ysqr=power(y[1],2)+power(y[2],2)
    z[1]=(y[1]*x[1]+x[2]*y[2])/ysqr
    z[2]=(y[1]*x[2]-y[2]*x[1])/ysqr
    return z
end function

global function c_sqrt(sequence x)
sequence y 
atom r,sqrtr,Theta,temp1,temp2
    --y=repeat(0,2)
    y={0,0,"c"}
    temp1=power(x[1],2)
    temp2=power(x[2],2)
    r=sqrt(temp1+temp2)
    sqrtr=sqrt(r)
    if x[1]!=0 then
	temp1=x[2]/x[1]
	Theta=arctan(temp1)
    else
	if x[2]>0 then 
	    Theta=PI/2
	else
	    Theta=-PI/2
	end if
	y[1]=sqrtr*cos(Theta/2)
	y[2]=sqrtr*sin(Theta/2)
    end if
    return y
end function

global function c_power(sequence x, atom p)
sequence y 
atom r,pwrr,Theta
    y={0,0,"c"}
    --y=repeat(0,2)
    r=sqrt(power(x[1],2)+power(x[2],2))
    pwrr=power(r,p)
    if x[1]!=0 then
	Theta=arctan(x[2]/x[1])
    else
	Theta=PI/2
	if x[1]<0 then
	    Theta=-Theta
	end if
    end if
    y[1]=pwrr*cos(p*Theta)
    y[2]=pwrr*sin(p*Theta)
    return y
end function

global function c_sinh(sequence x)
sequence y
--y=repeat(0,2)
    y={0,0,"c"}
    y[1]=sinh(x[1])*cos(x[2])
    y[2]=cosh(x[1])*sin(x[2])
    return y
end function

global function c_cosh(sequence x)
sequence y 
    --y=repeat(0,2)
    y={0,0,"c"}
    y[1]=cosh(x[1])*cos(x[2])
    y[2]=sinh(x[1])*sin(x[2])
    return y
end function
    
global function c_tanh(sequence x)
sequence y 
atom Denom
    --y=repeat(0,2)
    y={0,0,"c"}
    Denom=cosh(2*x[1])+cos(2*x[2])
    y[1]=sinh(2*x[1])/Denom
    y[2]= sin(2*x[2])/Denom
    return y
end function

global function c_coth(sequence x)
sequence y 
atom Denom
    --y=repeat(0,2)
    y={0,0,"c"}
    Denom=cosh(2*x[1])-cos(2*x[2])
    y[1]=sinh(2*x[1])/Denom
    y[2]=-sin(2*x[2])/Denom
    return y
end function

global function c_scalarmult(atom x, sequence y)
sequence z 
    --z=repeat(0,2)
    z={0,0,"c"}
    z[1]=x*y[1]
    z[2]=x*y[2]
    return z
end function

global function c_Imscalarmult(atom x, sequence y)
sequence z 
    --z=repeat(0,2)
    z={0,0,"c"}
--  xj*(A+Bj)=-xB+xAj
    z[1]=-x*y[2]
    z[2]=x*y[1]
    return z
end function

puts(1,"cmath.e - copyright 2004 Donald Cahela\n")
