include get.e
include poly.e

puts(1,"Test code for poly.e, a library of functions to manipulate polynomials\n")

sequence p1, p2, p3, ap, detap, dpdx, d2pdx2, proots
atom y1, y2, y3

puts(1,"\nTest polynomial multiplication\n")
p1={1,2,3}
p2={2,3,4,5}
--p1=1+2*x+3*x^2
--p2=2+3*x+4*x^2+5*x^3
--p3=2+7*x+16*x^2+22*x^3+22*x^4+15x^5

--Test polynomial multiplication
p3=poly_mult(p1,p2)

printf(1,"p1=%g",p1[1])
for i=2 to length(p1) do
    printf(1," + %g*x^%d",{p1[i],i-1})
end for
puts(1,"\n")

printf(1,"p2=%g",p2[1])
for i=2 to length(p2) do
    printf(1," + %g*x^%d",{p2[i],i-1})
end for
puts(1,"\n")

puts(1,"p3=p1*p2\n")
printf(1,"p3=%g",p3[1])
for i=2 to length(p3) do
    printf(1," + %g*x^%d",{p3[i],i-1})
end for
puts(1,"\n\n")

puts(1,"\nTest polynomial evaluation\n")
--Test polynomial evaluation
for i=0 to 3 do
    y1=poly_eval(i,p1)
    y2=poly_eval(i,p2)
    y3=poly_eval(i,p3)
    printf(1,"x=%d, p1=%g, p2=%g, p3=%g\n",{i,y1,y2,y3})
end for

--Test code for determinate and polynomial determinate evaluation.
puts(1,"\nTest code for determinate and polynomial determinate evaluation\n")

ap={{{8,1},{4,2},{3,2}},{{4,3},{3,2},{2,5}},{{3,2},{2,3},{1,1}}}
puts(1,"\napoly=")
?ap
detap=poly_determinate(3,ap)
printf(1,"determinate poly=%g",detap[1])
for i=2 to length(detap) do
    printf(1," + %g*x^%d",{detap[i],i-1})
end for
puts(1,"\n")

integer m
puts(1,"Hit any key to continue\n")
m=wait_key()
clear_screen()

detap={10,-100,10,-1,0.1}
puts(1,"polynomial to test root finder=\n")
printf(1,"p4=%g",detap[1])
for i=2 to length(detap) do
    printf(1," + %g*x^%d",{detap[i],i-1})
end for
puts(1,"\n\n")
dpdx=poly_derivative(detap)
d2pdx2=poly_derivative(dpdx)

atom z
puts(1,"(x,f(x),df(x)/dx,d2f(x)/dx2)\n")
for i=1 to 40 by 2 do
    z=i-20
    printf(1,"%g, %g, %g, %g\n",{z,poly_eval(z,detap),poly_eval(z,dpdx),poly_eval(z,d2pdx2)})
end for
puts(1,"\n\n")
proots=poly_roots_direct(-100, 100, detap, 1e-10, 1000)
puts(1,"Roots of polynomial=\n")
for i=1 to length(proots) do
    printf(1,"(x,err)=(%g,%g)\n",{proots[i],poly_eval(proots[i],detap)})
end for

puts(1,"End of test code for poly.e - Don Cahela, 2006\n")

