--Test code for statfunc.e
include statiscs.e
atom  gammaval

for i=1 to 7 do
    gammaval=gamma_func_calc(i)
    printf(1,"gamma(%g)=%g, factorial(%g)=%g\n",{i,gammaval,i-1,factorial(i-1)})
end for

puts(1,"\nTest of Fdist calc using recusive Simpson's rule integration\n")
atom Fdist, hval, ndist, tdist, Csqdist, F
integer m1, n1, df
m1=10
for i=1 to 10 by 3 do
    n1=6
    hval=4.06
    Fdist=Fdist_calc(i,n1,hval)
printf(1,"Integral for F(F)=Fdist(%d, %d, %g)=%g\n",{i,n1,hval,Fdist})
end for

hval=2
ndist=normal_dist_calc(hval)
printf(1,"\nIntegral of normal distribution for z=%g is %g\n",{hval,ndist})

df=9
hval=2
tdist=student_dist_calc(df,hval)
printf(1,"\nIntegral of student-t distribution for (df=%d, z=%d)=%g\n",{df,hval,tdist})

hval=-2
tdist=student_dist_calc(df,hval)
printf(1,"Integral of student-t distribution for (df=%d, z=%d)=%g\n",{df,hval,tdist})

hval=20
Csqdist=Chi_Sqr_dist_calc(df,hval)
printf(1,"\nIntegral of Chi square distribution for (df=%d, z=%d)=%g\n\n",{df,hval,Csqdist})

atom zofF
puts(1,"Test inverse distribution functions\n")

F=0.975
df=30
printf(1,"t for student distribution, df=%d, F=%g is t=",{df,F})
zofF=inverse_student_tdist(df,F)
printf(1,"%g\n",zofF)

zofF=inverse_normal_dist(F)
printf(1,"z for normal distribution=%g is z=%g\n",{F,zofF})

--Warning: the inverse Chi Sqr distribution can take a very long time 
--for large degrees of freedom (ie > 15.
df=10
F=0.75
zofF=inverse_Chi_Sqr_dist(df,F)
printf(1,"ChiSqr for student distribution, df=%d, F=%g is X2=%g\n",{df,F,zofF})

F=0.95
n1=10

m1=4
printf(1,"\nF for F(F(%d,%d))=%g is F=",{m1,n1,F})
zofF=inverse_Fdist(m1,n1,F)
printf(1,"%g\n",zofF)

m1=3
printf(1,"F for F(F(%d,%d))=%g is F=",{m1,n1,F})
zofF=inverse_Fdist(m1,n1,F)
printf(1,"%g\n",zofF)

m1=2
printf(1,"F for F(F(%d,%d))=%g is F=",{m1,n1,F})
zofF=inverse_Fdist(m1,n1,F)
printf(1,"%g\n",zofF)

m1=1
printf(1,"F for F(F(%d,%d))=%g is F=",{m1,n1,F})
zofF=inverse_Fdist(m1,n1,F)
printf(1,"%g\n",zofF)

puts(1,"\nEnd of statistical function tests\n")
